package com.zksy.web.controller.basicData;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.annotation.Log;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmLiquidationInfo;
import com.zksy.system.basicData.service.CrmLiquidationInfoService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 清算信息Controller
 *
 * @author sy
 * @date 2024-06-05
 */
@RestController
@RequestMapping("/crmLiquidationInfo")
@Api(tags = "清算信息", description = "清算信息desc")
public class CrmLiquidationInfoController extends BaseController{

    @Autowired
    private CrmLiquidationInfoService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "清算信息搜索getById")
    public CrmLiquidationInfo getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "清算信息分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "清算信息查询所有")
    public List<CrmLiquidationInfo> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增清算信息
     */
    @PostMapping("/save")
    @ApiOperation(value = "清算信息新增")
    @Log(title = "新增清算信息", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmLiquidationInfo crmLiquidationInfo) {
        return service.save(crmLiquidationInfo);
    }

    /**
     * 修改清算信息
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "清算信息修改")
    @Log(title = "修改清算信息", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmLiquidationInfo crmLiquidationInfo) {
        return service.updateById(crmLiquidationInfo);
    }

    /**
     * 导入清算信息
     */
    @ApiOperation("清算信息导入")
    @Log(title = "清算信息", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmLiquidationInfo> crmLiquidationInfoAll = service.list();
            List<CrmLiquidationInfo> list = ExcelUtils.readMultipartFile(file, CrmLiquidationInfo.class,CrmLiquidationInfo.class.getDeclaredFields().length - 2);
            if(crmLiquidationInfoAll != null && crmLiquidationInfoAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("清算信息导出")
    @Log(title = "清算信息", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmLiquidationInfo> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"清算信息",wrapperList,CrmLiquidationInfo.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "清算信息", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除清算信息", notes = "删除清算信息")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"清算信息模板");
    }
}

